/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 09/01/2019
 --------------------------------------------------------
*/
package com.portofolio.entity;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import  javax.persistence.*;
import  javax.validation.constraints.*;

import org.hibernate.annotations.ForeignKey;

import  lombok.AllArgsConstructor;
import  lombok.Getter;
import  lombok.NoArgsConstructor;
import  lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.HariId;


@Entity
@Table(name = "Hari_M",indexes = {@Index(name = "Hari_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class Hari {
    
    @EmbeddedId
    private HariId id ;
    
    private static final String cDefNamaHari = VARCHAR + AWAL_KURUNG + 10 + AKHIR_KURUNG ;
    @Column(name = "NamaHari", columnDefinition = cDefNamaHari)
    @NotNull(message = "hari.namahari.notnull")
    private String namaHari;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 10 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "hari.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefNoUrutHariKe =INTEGER;
    @Column(name = "NoUrutHariKe", columnDefinition = cDefNoUrutHariKe)
    @NotNull(message = "hari.nourutharike.notnull")
    private Integer noUrutHariKe;
    
    private static final String cDefFormatAngka =INTEGER;
    @Column(name = "FormatAngka", columnDefinition = cDefFormatAngka)
    private Integer formatAngka;
    
    private static final String cDefFormatAngkaRomawi = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG ;
    @Column(name = "FormatAngkaRomawi", columnDefinition = cDefFormatAngkaRomawi)
    private String formatAngkaRomawi;
        
    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;
    
    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;
        
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "hari.statusenabled.notnull")
    private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "hari.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "hari.version.notnull")
    private Integer version;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    //@ForeignKey(name="none")
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
     private Profile profile;
     
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    //@ForeignKey(name="none")
    @JoinColumns({
        @JoinColumn(name="KdNegara", referencedColumnName="KdNegara",insertable=false, updatable=false),
    })
     private Negara negara;
     

}
